두 타임스탬프 사이의 모든 로그를 추출하고 싶습니다. 일부 행에는 타임스탬프가 없을 수도 있지만 해당 행도 필요합니다. 즉, 두 개의 타임스탬프에 속하는 모든 행을 원합니다. 내 로그 구조는 다음과 같습니다.
[2014-04-07 23:59:58] CheckForCallAction [ERROR] Exception caught in +CheckForCallAction :: null
--Checking user--
Post
[2014-04-08 00:00:03] MobileAppRequestFilter [DEBUG] Action requested checkforcall
2014-04-07 23:00
와 사이의 모든 것을 추출하고 싶다고 가정해 보겠습니다 2014-04-08 02:00
.
시작 또는 종료 타임스탬프가 로그에 없을 수도 있지만 이 두 타임스탬프 사이의 모든 행을 원합니다.
답변1
다음을 위해 사용할 수 있습니다 awk
:
$ awk -F'[]]|[[]' \
'$0 ~ /^\[/ && $2 >= "2014-04-07 23:00" { p=1 }
$0 ~ /^\[/ && $2 >= "2014-04-08 02:00" { p=0 }
p { print $0 }' log
어디:
-F
정규식을 사용하여 문자를 지정[
하고 필드 구분 기호로 사용]
$0
전체 라인 인용$2
참조 날짜 필드p
실제 인쇄를 보호하는 데 사용되는 부울 변수$0 ~ /regex/
정규식이 일치하면 true$0
>=
문자열을 사전순으로 비교하는 데 사용됩니다(예:strcmp()
).
다양성
위의 명령줄은 다음을 구현합니다.오른쪽 오픈 시간 간격성냥. 닫힌 간격 의미를 얻으려면 올바른 날짜를 추가하면 됩니다. 예:
$ awk -F'[]]|[[]' \
'$0 ~ /^\[/ && $2 >= "2014-04-07 23:00" { p=1 }
$0 ~ /^\[/ && $2 >= "2014-04-08 02:00:01" { p=0 }
p { print $0 }' log
다른 형식의 타임스탬프를 일치시키려면 $0 ~ /^\[/
하위 표현식을 수정해야 합니다. 인쇄 켜기/끄기 논리에 타임스탬프가 없는 줄을 무시하는 데 사용되었습니다.
예를 들어 중괄호가 YYYY-MM-DD HH24:MI:SS
없는 타임스탬프 형식의 경우 다음과 같이 명령을 수정할 수 있습니다.[]
$ awk \
'$0 ~ /^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-2][0-9]:[0-5][0-9]:[0-5][0-9]/
{
if ($1" "$2 >= "2014-04-07 23:00") p=1;
if ($1" "$2 >= "2014-04-08 02:00:01") p=0;
}
p { print $0 }' log
(필드 구분 기호도 변경되었습니다. 공백/비 공백으로 전환, 기본값)
답변2
체크아웃 시간 dategrep
은 다음과 같습니다https://github.com/mdom/dategrep
설명하다:
dategrep은 지정된 입력 파일에서 날짜 범위와 일치하는 행을 검색하고 이를 표준 출력으로 인쇄합니다.
dategrep이 검색 가능한 파일에서 작동하는 경우 이진 검색을 수행하여 첫 번째 줄과 마지막 줄을 찾을 수 있으므로 매우 효율적으로 인쇄할 수 있습니다. dategrep은 filename 인수가 하이픈인 경우 표준 입력에서도 읽을 수 있지만 이 경우 각 줄을 구문 분석해야 하므로 속도가 느려집니다.
사용 예:
dategrep --start "12:00" --end "12:15" --format "%b %d %H:%M:%S" syslog
dategrep --end "12:15" --format "%b %d %H:%M:%S" syslog
dategrep --last-minutes 5 --format "%b %d %H:%M:%S" syslog
dategrep --last-minutes 5 --format rsyslog syslog
cat syslog | dategrep --end "12:15" -
이러한 제한으로 인해 특정 문제에 적합하지 않을 수도 있습니다.
현재 dategrep은 구문 분석할 수 없는 행을 찾는 즉시 종료됩니다. 향후 버전에서는 이를 구성할 수 있습니다.
답변3
대체 도구 awk
또는 비표준 도구는 grep
GNU를 사용하는 컨텍스트 grep입니다. GNU에서는 인쇄 grep
할 일치 항목 뒤의 줄 수 -A
와 인쇄할 앞의 줄 수를 지정할 수 있습니다.-B
[davisja5@xxxxxxlp01 ~]$ cat test.txt
Ignore this line, please.
This one too while you're at it...
[2014-04-07 23:59:58] CheckForCallAction [ERROR] Exception caught in +CheckForCallAction :: null
--Checking user--
Post
[2014-04-08 00:00:03] MobileAppRequestFilter [DEBUG] Action requested checkforcall
we don't
want these lines.
[davisja5@xxxxxxlp01 ~]$ egrep "^\[2014-04-07 23:59:58\]" test.txt -A 10000 | egrep "^\[2014-04-08 00:00:03\]" -B 10000
[2014-04-07 23:59:58] CheckForCallAction [ERROR] Exception caught in +CheckForCallAction :: null
--Checking user--
Post
[2014-04-08 00:00:03] MobileAppRequestFilter [DEBUG] Action requested checkforcall
위의 내용은 기본적으로 grep
시작하려는 패턴과 일치하는 줄을 따라 10,000줄을 인쇄하도록 지시합니다. 그러면 효과적으로 출력이 원하는 곳에서 시작하여 두 번째 패턴이 egrep
있는 동안 끝까지(희망적으로) 끝까지 가게 됩니다. 파이프라인 끝 구분 기호가 있는 줄과 그 앞에 오는 10,000줄만 인쇄하도록 지시합니다. 이 두 가지의 최종 결과는 중지하라고 지시한 지점을 지나는 것이 아니라 원하는 지점에서 시작하는 것입니다.
10,000은 제가 생각해낸 숫자일 뿐입니다. 출력이 너무 길다고 생각되면 자유롭게 100만으로 변경하세요.
답변4
sed를 사용하세요:
#!/bin/bash
E_BADARGS=23
if [ $# -ne "3" ]
then
echo "Usage: `basename $0` \"<start_date>\" \"<end_date>\" file"
echo "NOTE:Make sure to put dates in between double quotes"
exit $E_BADARGS
fi
isDatePresent(){
#check if given date exists in file.
local date=$1
local file=$2
grep -q "$date" "$file"
return $?
}
convertToEpoch(){
#converts to epoch time
local _date=$1
local epoch_date=`date --date="$_date" +%s`
echo $epoch_date
}
convertFromEpoch(){
#converts to date/time format from epoch
local epoch_date=$1
local _date=`date --date="@$epoch_date" +"%F %T"`
echo $_date
}
getDates(){
# collects all dates at beginning of lines in a file, converts them to epoch and returns a sequence of numbers
local file="$1"
local state="$2"
local i=0
local date_array=( )
if [[ "$state" -eq "S" ]];then
datelist=`cat "$file" | sed -r -e "s/^\[([^\[]+)\].*/\1/" | egrep "^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}:[0-9]{2}"`
elif [[ "$state" -eq "E" ]];then
datelist=`tac "$file" | sed -r -e "s/^\[([^\[]+)\].*/\1/" | egrep "^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}:[0-9]{2}"`
else
echo "Something went wrong while getting dates..." 1>&2
exit 500
fi
while read _date
do
epoch_date=`convertToEpoch "$_date"`
date_array[$i]=$epoch_date
#echo "$_date" "$epoch_date" 1>&2
(( i++ ))
done<<<"$datelist"
echo ${date_array[@]}
}
findneighbours(){
# search next best date if date is not in the file using recursivity
IFS="$old_IFS"
local elt=$1
shift
local state="$1"
shift
local -a array=( "$@" )
index_pivot=`expr ${#array[@]} / 2`
echo "#array="${#array[@]} ";array="${array[@]} ";index_pivot="$index_pivot 1>&2
if [ "$index_pivot" -eq 1 -a ${#array[@]} -eq 2 ];then
if [ "$state" == "E" ];then
echo ${array[0]}
elif [ "$state" == "S" ];then
echo ${array[(( ${#array[@]} - 1 ))]}
else
echo "State" $state "undefined" 1>&2
exit 100
fi
else
echo "elt with index_pivot="$index_pivot":"${array[$index_pivot]} 1>&2
if [ $elt -lt ${array[$index_pivot]} ];then
echo "elt is smaller than pivot" 1>&2
array=( ${array[@]:0:(($index_pivot + 1)) } )
else
echo "elt is bigger than pivot" 1>&2
array=( ${array[@]:$index_pivot:(( ${#array[@]} - 1 ))} )
fi
findneighbours "$elt" "$state" "${array[@]}"
fi
}
findFirstDate(){
local file="$1"
echo "Looking for first date in file" 1>&2
while read line
do
echo "$line" | egrep -q "^\[[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}:[0-9]{2}\]" &>/dev/null
if [ "$?" -eq "0" ]
then
#echo "line=" "$line" 1>&2
firstdate=`echo "$line" | sed -r -e "s/^\[([^\[]+)\].*/\1/"`
echo "$firstdate"
break
else
echo $? 1>&2
fi
done< <( cat "$file" )
}
findLastDate(){
local file="$1"
echo "Looking for last date in file" 1>&2
while read line
do
echo "$line" | egrep -q "^\[[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}:[0-9]{2}\]" &>/dev/null
if [ "$?" -eq "0" ]
then
#echo "line=" "$line" 1>&2
lastdate=`echo "$line" | sed -r -e "s/^\[([^\[]+)\].*/\1/"`
echo "$lastdate"
break
else
echo $? 1>&2
fi
done< <( tac "$file" )
}
findBestDate(){
IFS="$old_IFS"
local initdate="$1"
local file="$2"
local state="$3"
local first_elts="$4"
local last_elts="$5"
local date_array=( )
local initdate_epoch=`convertToEpoch "$initdate"`
if [[ $initdate_epoch -lt $first_elt ]];then
echo `convertFromEpoch "$first_elt"`
elif [[ $initdate_epoch -gt $last_elt ]];then
echo `convertFromEpoch "$last_elt"`
else
date_array=( `getDates "$file" "$state"` )
echo "date_array="${date_array[@]} 1>&2
#first_elt=${date_array[0]}
#last_elt=${date_array[(( ${#date_array[@]} - 1 ))]}
echo `convertFromEpoch $(findneighbours "$initdate_epoch" "$state" "${date_array[@]}")`
fi
}
main(){
init_date_start="$1"
init_date_end="$2"
filename="$3"
echo "problem start.." 1>&2
date_array=( "$init_date_start","$init_date_end" )
flag_array=( 0 0 )
i=0
#echo "$IFS" | cat -vte
old_IFS="$IFS"
#changing separator to avoid whitespace issue in date/time format
IFS=,
for _date in ${date_array[@]}
do
#IFS="$old_IFS"
#echo "$IFS" | cat -vte
if isDatePresent "$_date" "$filename";then
if [ "$i" -eq 0 ];then
echo "Starting date exists" 1>&2
#echo "date_start=""$_date" 1>&2
date_start="$_date"
else
echo "Ending date exists" 1>&2
#echo "date_end=""$_date" 1>&2
date_end="$_date"
fi
else
if [ "$i" -eq 0 ];then
echo "start date $_date not found" 1>&2
else
echo "end date $_date not found" 1>&2
fi
flag_array[$i]=1
fi
#IFS=,
(( i++ ))
done
IFS="$old_IFS"
if [ ${flag_array[0]} -eq 1 -o ${flag_array[1]} -eq 1 ];then
first_elt=`convertToEpoch "$(findFirstDate "$filename")"`
last_elt=`convertToEpoch "$(findLastDate "$filename")"`
border_dates_array=( "$first_elt","$last_elt" )
#echo "first_elt=" $first_elt "last_elt=" $last_elt 1>&2
i=0
IFS=,
for _date in ${date_array[@]}
do
if [ $i -eq 0 -a ${flag_array[$i]} -eq 1 ];then
date_start=`findBestDate "$_date" "$filename" "S" "${border_dates_array[@]}"`
elif [ $i -eq 1 -a ${flag_array[$i]} -eq 1 ];then
date_end=`findBestDate "$_date" "$filename" "E" "${border_dates_array[@]}"`
fi
(( i++ ))
done
fi
sed -r -n "/^\[${date_start}\]/,/^\[${date_end}\]/p" "$filename"
}
main "$1" "$2" "$3"
파일로 복사하세요. 디버그 정보를 보고 싶지 않으면 디버그 정보가 stderr로 전송되므로 "2>/dev/null"만 추가하면 됩니다.